<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
    <xsl:output method="xml" encoding="UTF-8"/>
    <xsl:template match="/testsuite">
        <testsuite>
            <xsl:for-each select="testcase">
                <testcase>
                    <xsl:attribute name="number">
                        <xsl:value-of select="@number"/>
                    </xsl:attribute>
                    <results xmlns="www.t-plan.com" xmlns:b="http://schemas.datacontract.org/2004/07/TPlan.SOA">
                        <xsl:for-each select="step">
                            <b:TestCaseResult>
                                <b:ActualResult>
                                    <xsl:value-of select="@actual"/>
                                </b:ActualResult>
                                <b:ExpectedResult>
                                    <xsl:value-of select="@expected"/>
                                </b:ExpectedResult>
                                <b:InputData>
                                    <xsl:value-of select="@instruct"/>
                                </b:InputData>
                                <b:Name>
                                    <xsl:value-of select="@name"/>
                                </b:Name>
                                <b:Notes>
                                    <xsl:value-of select="@notes"/>
                                </b:Notes>
                                <b:Status>
                                    <xsl:choose>
                                        <xsl:when test="@result = 'fail'">EE95D6335B7511D1978D0000C0D9D069</xsl:when>
                                        <xsl:when test="@result = 'pass'">EE95D6345B7511D1978D0000C0D9D069</xsl:when>
                                        <xsl:when test="@result = 'nt'">EE95D6325B7511D1978D0000C0D9D069</xsl:when>
                                        <xsl:when test="@result = 'na'">EE95D6355B7511D1978D0000C0D9D069</xsl:when>
                                    </xsl:choose>
                                </b:Status>
                            </b:TestCaseResult>
                        </xsl:for-each>
                    </results>
                </testcase>
            </xsl:for-each>
        </testsuite>
    </xsl:template>
</xsl:stylesheet>
