@echo off
reg Query "HKLM\Hardware\Description\System\CentralProcessor\0" | find /i "x86" > NUL && set OSA=32BIT || set OSA=64BIT

rem First test out if there is an update script
set EXITCODE=0

set "UFILE=%~dp0%\update.bat"
if exist "%UFILE%" goto :update

goto :uend

:update
call "%UFILE%"
del "%UFILE%"

:uend

rem These are expected paths of the Java plugins
set "J32=%~dp0%java\win-i386\bin\"
set "J64=%~dp0%java\win-amd64\bin\"
set JHOME=

if %OSA%==64BIT goto :j64
if %OSA%==32BIT goto :j32
goto :jend

:j64
rem On Windows x64 prefer 64-bit Java but also accept a 32-bit one
if exist "%J32%java.exe" set "JHOME=%J32%"
if exist "%J64%java.exe" set "JHOME=%J64%"
goto :jend

:j32
rem Windows x32 requires x32 Java
if exist "%J32%java.exe" set "JHOME=%J32%"
goto :jend

:jend

call :cmdline %CMDCMDLINE%

rem Updated in 7.0 - switch to the script's folder
setlocal
cd %~dp0%

rem RB-734: FlatLaf reports failure to access the sun.awt.shell package (since 7.1.1)
set "FLAGS="
("%JHOME%java" -version 2>&1 | find "1.8.0_") > nul 2>&1
if errorlevel 1 (
    set "FLAGS=--add-opens java.desktop/sun.awt.shell=ALL-UNNAMED"
)

IF /I "%MYSWITCH%" == "/C" start /B  "T-Plan Robot Enterprise" "%JHOME%javaw" -Dsun.java2d.d3d=false -Xmx512m -Djava.system.class.loader=com.tplan.robot.util.LazyClassLoader %FLAGS% -classpath ".\*;libs\*;plugins\*;libs\selenium\*;libs\poi\*" com.tplan.robot.ApplicationSupport %*
IF /I NOT "%MYSWITCH%" == "/C" "%JHOME%java" -Dsun.java2d.d3d=false -Xmx512m -Djava.system.class.loader=com.tplan.robot.util.LazyClassLoader %FLAGS% -classpath ".\*;libs\*;plugins\*;libs\selenium\*;libs\poi\*" com.tplan.robot.ApplicationSupport %*

endlocal & set EXITCODE=%ERRORLEVEL%

IF %ERRORLEVEL% EQU 9009 goto :no_java
IF /I "%MYSWITCH%" == "/C" exit %EXITCODE%
IF /I NOT "%MYSWITCH%" == "/C" exit /B %EXITCODE%

:no_java
echo(

echo Please make sure that you have Java 1.8 or higher installed
echo and configured as is described in the Release Notes at:
echo(
echo   https://docs.t-plan.com/robot/release-notes#ReleaseNotes-java
echo(
echo Press any key to exit...
pause >nul
goto :eof

:cmdline
SET MYSWITCH=%2

if exist "%UFILE%" goto :endupdate
goto :eof

:endupdate
call "%UFILE%"
del "%UFILE%"


